routes/web.php
<?php

use App\Http\Controllers\FormController;
use App\Http\Controllers\HomeController;
use App\Http\Controllers\SubscriptionController;
use App\Http\Controllers\UserController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "web" middleware group. Make something great!
|
*/

Route::get('/', [HomeController::class, 'landing'])->name('landing');
Route::get('/subscription-form/{subscription}', [HomeController::class, 'form'])->name('subscriptionForm');
Route::post('/subscription-form/{subscription}', [HomeController::class, 'submit'])->name('submissionForm');

Auth::routes();

Route::group(['middleware' => 'auth'], function () {
    Route::get('/dashboard', [HomeController::class, 'index'])->name('dashboard');

    Route::middleware('role:admin')->prefix('user')->name('user.')->group(function () {
        Route::get('', [UserController::class, 'index'])->name('index');
        Route::get('/edit/{user}', [UserController::class, 'edit'])->name('edit');
        Route::post('/update/{user}', [UserController::class, 'update'])->name('update');
    });

    Route::middleware('role:admin')->prefix('subscription')->name('subscription.')->group(function () {
        Route::get('', [SubscriptionController::class, 'index'])->name('index');
        Route::get('/create', [SubscriptionController::class, 'create'])->name('create');
        Route::post('/store', [SubscriptionController::class, 'store'])->name('store');
        Route::get('/edit/{subscription}', [SubscriptionController::class, 'edit'])->name('edit');
        Route::put('/update/{subscription}', [SubscriptionController::class, 'update'])->name('update');
    });

    Route::middleware('role:admin')->prefix('form')->name('form.')->group(function () {
        Route::get('', [FormController::class, 'index'])->name('index');
        Route::get('/create', [FormController::class, 'create'])->name('create');
        Route::post('/store', [FormController::class, 'store'])->name('store');
        Route::get('/edit/{form}', [FormController::class, 'edit'])->name('edit');
        Route::put('/update/{form}', [FormController::class, 'update'])->name('update');
        Route::get('/builder/{form}', [FormController::class, 'builder'])->name('builder');
        Route::post('/builder/{form}', [FormController::class, 'storeBuilder'])->name('builder.store');
    });
});

app/Models/Subscription.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Subscription extends Model
{
    use HasFactory;

    protected $guarded = [];

    public function scopeSearch($query, $value)
    {
        $query->where('name', 'like', '%' . $value . '%')
            ->orWhere('description', 'like', '%' . $value . '%')
            ->orWhere('price', 'like', '%' . $value . '%');
    }

    public function form()
    {
        return $this->belongsTo(Form::class);
    }

    public function submission()
    {
        return $this->hasOne(FormSubmission::class, 'subscriber_id');
    }
}

app/Http/Controllers/SubscriptionController.php
<?php

namespace App\Http\Controllers;

use App\Models\Form;
use App\Models\Subscription;
use Illuminate\Http\Request;
use RealRashid\SweetAlert\Facades\Alert;

class SubscriptionController extends Controller
{
    public function index()
    {
        return view('subscription.index');
    }

    public function create()
    {
        $forms = Form::all();

        return view('subscription.create', ['forms' => $forms]);
    }

    public function store(Request $request)
    {
        $request->validate([
            'name' => 'required|string',
            'description' => 'required|string|min:3',
            'price' => 'required|numeric',
            'form_id' => 'required'
        ]);

        Subscription::create($request->all());

        Alert::success('Success!', 'Subscription plan created successfully');

        return redirect()->route('subscription.index');
    }

    public function edit(Subscription $subscription)
    {
        $forms = Form::all();

        return view('subscription.edit', ['subscription' => $subscription, 'forms' => $forms]);
    }

    public function update(Request $request, Subscription $subscription)
    {
        $request->validate([
            'name' => 'required|string',
            'description' => 'required|string|min:3',
            'price' => 'required|numeric',
            'form_id' => 'required'
        ]);

        $subscription->update($request->all());

        Alert::success('Success!', 'Subscription plan updated successfully');

        return redirect()->route('subscription.index');
    }
}

app/Livewire/SubscriptionTable.php
<?php

namespace App\Livewire;

use App\Models\Subscription;
use Livewire\Attributes\Url;
use Livewire\Component;
use Livewire\WithPagination;

class SubscriptionTable extends Component
{
    use WithPagination;

    #[Url(history: true)]
    public $perPage = 5;

    #[Url(history: true)]
    public $search = "";

    #[Url(history: true)]
    public $sortBy = "created_at";

    #[Url(history: true)]
    public $sortDir = "desc";

    protected $listeners = ['deleteSubs'];

    public function updatedSearch()
    {
        $this->resetPage();
    }

    public function setSortBy($sortByField)
    {
        if ($this->sortBy == $sortByField) {
            $this->sortDir = ($this->sortDir == "asc") ? "desc" : "asc";
            return;
        }
        $this->sortBy = $sortByField;
        $this->sortDir = "desc";
    }

    public function render()
    {
        $subscriptions = Subscription::with('form')->search($this->search)->orderBy($this->sortBy, $this->sortDir)->paginate($this->perPage);

        return view('livewire.subscription-table', [
            'subscriptions' => $subscriptions,
            'totalResults' => $subscriptions->total(),
            'firstResult' => $subscriptions->firstItem(),
            'lastResult' => $subscriptions->lastItem()
        ]);
    }

    public function confirmDeleteSub($id)
    {
        $this->dispatch('swal:confirm', type: 'question', text: 'Are you sure you want to delete this subscription plan ?', id: $id, listener: 'deleteSubs');
    }

    public function deleteSubs($id)
    {
        $subscription = Subscription::find($id);

        $subscription->delete();

        $this->dispatch('swal:modal', type: 'success', text: 'Subscription deleted successfully', title: 'Success!');
    }
}

resources/views/subscription/create.blade.php
@extends('layouts.main')

@section('content')
    <div class="row mb-5 mb-xl-10">
        <div class="card mb-5 mb-xl-10">
            <!--begin::Card header-->
            <div class="card-header border-0 cursor-pointer" role="button" data-bs-toggle="collapse" data-bs-target="#kt_account_profile_details" aria-expanded="true"
                aria-controls="kt_account_profile_details">
                <!--begin::Card title-->
                <div class="card-title m-0">
                    <h3 class="fw-bold m-0">Create Subscription Plan</h3>
                </div>
                <!--end::Card title-->
            </div>
            <!--begin::Card header-->
            <!--begin::Content-->
            <!--begin::Form-->
            <form class="form fv-plugins-bootstrap5 fv-plugins-framework" method="POST" action="{{ route('subscription.store') }}">
                @csrf
                <!--begin::Card body-->
                <div class="card-body border-top p-9">
                    <!--begin::Input group-->
                    <div class="row mb-6">
                        <!--begin::Label-->
                        <label class="col-lg-4 col-form-label required fw-semibold fs-6">Subscription Name</label>
                        <!--end::Label-->
                        <!--begin::Col-->
                        <div class="col-lg-8">
                            <input type="text" name="name" class="form-control form-control-lg form-control-solid mb-3 mb-lg-0" value="{{ old('name') }}">
                            @error('name')
                                <div class="fv-plugins-message-container fv-plugins-message-container--enabled invalid-feedback">{{ $message }}</div>
                            @enderror
                        </div>
                        <!--end::Col-->
                    </div>
                    <!--end::Input group-->

                    <!--begin::Input group-->
                    <div class="row mb-6">
                        <!--begin::Label-->
                        <label class="col-lg-4 col-form-label required fw-semibold fs-6">Description</label>
                        <!--end::Label-->
                        <!--begin::Col-->
                        <div class="col-lg-8 fv-row fv-plugins-icon-container">
                            <textarea name="description" class="form-control form-control form-control-solid" rows="4" data-kt-autosize="true">{{ old('description') }}</textarea>
                            @error('description')
                                <div class="fv-plugins-message-container fv-plugins-message-container--enabled invalid-feedback">{{ $message }}</div>
                            @enderror
                        </div>
                        <!--end::Col-->
                    </div>
                    <!--end::Input group-->
                    <!--begin::Input group-->
                    <div class="row mb-6">
                        <!--begin::Label-->
                        <label class="col-lg-4 col-form-label required fw-semibold fs-6">Price</label>
                        <!--end::Label-->
                        <!--begin::Col-->
                        <div class="col-lg-8 fv-row fv-plugins-icon-container">
                            <input type="text" name="price" class="form-control form-control-lg form-control-solid" value="{{ old('price') }}">
                            @error('price')
                                <div class="fv-plugins-message-container fv-plugins-message-container--enabled invalid-feedback">{{ $message }}</div>
                            @enderror
                        </div>
                        <!--end::Col-->
                    </div>
                    <!--end::Input group-->
                    <!--begin::Input group-->
                    <div class="row mb-6">
                        <!--begin::Label-->
                        <label class="col-lg-4 col-form-label fw-semibold fs-6">Form Template</label>
                        <!--end::Label-->
                        <!--begin::Col-->
                        <div class="col-lg-8 fv-row fv-plugins-icon-container">
                            <select class="form-select form-select-solid" name="form_id">
                                <option value="{{ null }}">-- Choose Form --</option>
                                @foreach ($forms as $form)
                                    <option value="{{ $form->id }}" {{ old('form_id') == $form->id ? 'selected' : '' }}>{{ $form->name }}</option>
                                @endforeach
                            </select>
                            @error('form_id')
                                <div class="fv-plugins-message-container fv-plugins-message-container--enabled invalid-feedback">{{ $message }}</div>
                            @enderror
                        </div>
                        <!--end::Col-->
                    </div>
                    <!--end::Input group-->
                </div>
                <!--end::Card body-->
                <!--begin::Actions-->
                <div class="card-footer d-flex justify-content-end py-6 px-9">
                    <button type="submit" class="btn btn-primary">Submit</button>
                </div>
                <!--end::Actions-->
            </form>
            <!--end::Form-->
            <!--end::Content-->
        </div>
    </div>
@endsection

resources/views/subscription/edit.blade.php
@extends('layouts.main')

@section('content')
    <div class="row mb-5 mb-xl-10">
        <div class="card mb-5 mb-xl-10">
            <!--begin::Card header-->
            <div class="card-header border-0 cursor-pointer" role="button" data-bs-toggle="collapse" data-bs-target="#kt_account_profile_details" aria-expanded="true"
                aria-controls="kt_account_profile_details">
                <!--begin::Card title-->
                <div class="card-title m-0">
                    <h3 class="fw-bold m-0">Edit Subscription Plan</h3>
                </div>
                <!--end::Card title-->
            </div>
            <!--begin::Card header-->
            <!--begin::Content-->
            <!--begin::Form-->
            <form class="form fv-plugins-bootstrap5 fv-plugins-framework" method="POST" action="{{ route('subscription.update', $subscription) }}">
                @method('PUT')
                @csrf
                <!--begin::Card body-->
                <div class="card-body border-top p-9">
                    <!--begin::Input group-->
                    <div class="row mb-6">
                        <!--begin::Label-->
                        <label class="col-lg-4 col-form-label required fw-semibold fs-6">Subscription Name</label>
                        <!--end::Label-->
                        <!--begin::Col-->
                        <div class="col-lg-8">
                            <input type="text" name="name" class="form-control form-control-lg form-control-solid mb-3 mb-lg-0" value="{{ $subscription->name }}">
                            @error('name')
                                <div class="fv-plugins-message-container fv-plugins-message-container--enabled invalid-feedback">{{ $message }}</div>
                            @enderror
                        </div>
                        <!--end::Col-->
                    </div>
                    <!--end::Input group-->

                    <!--begin::Input group-->
                    <div class="row mb-6">
                        <!--begin::Label-->
                        <label class="col-lg-4 col-form-label required fw-semibold fs-6">Description</label>
                        <!--end::Label-->
                        <!--begin::Col-->
                        <div class="col-lg-8 fv-row fv-plugins-icon-container">
                            <textarea name="description" class="form-control form-control form-control-solid" rows="4" data-kt-autosize="true">{{ $subscription->description }}</textarea>
                            @error('description')
                                <div class="fv-plugins-message-container fv-plugins-message-container--enabled invalid-feedback">{{ $message }}</div>
                            @enderror
                        </div>
                        <!--end::Col-->
                    </div>
                    <!--end::Input group-->
                    <!--begin::Input group-->
                    <div class="row mb-6">
                        <!--begin::Label-->
                        <label class="col-lg-4 col-form-label required fw-semibold fs-6">Price</label>
                        <!--end::Label-->
                        <!--begin::Col-->
                        <div class="col-lg-8 fv-row fv-plugins-icon-container">
                            <input type="text" name="price" class="form-control form-control-lg form-control-solid" value="{{ $subscription->price }}">
                            @error('price')
                                <div class="fv-plugins-message-container fv-plugins-message-container--enabled invalid-feedback">{{ $message }}</div>
                            @enderror
                        </div>
                        <!--end::Col-->
                    </div>
                    <!--end::Input group-->
                    <!--begin::Input group-->
                    <div class="row mb-6">
                        <!--begin::Label-->
                        <label class="col-lg-4 col-form-label fw-semibold fs-6">Form Template</label>
                        <!--end::Label-->
                        <!--begin::Col-->
                        <div class="col-lg-8 fv-row fv-plugins-icon-container">
                            <select class="form-select form-select-solid" name="form_id">
                                <option value="{{ null }}">-- Choose Form --</option>
                                @foreach ($forms as $form)
                                    <option value="{{ $form->id }}" {{ $subscription->form_id == $form->id ? 'selected' : '' }}>{{ $form->name }}</option>
                                @endforeach
                            </select>
                            @error('form_id')
                                <div class="fv-plugins-message-container fv-plugins-message-container--enabled invalid-feedback">{{ $message }}</div>
                            @enderror
                        </div>
                        <!--end::Col-->
                    </div>
                    <!--end::Input group-->
                </div>
                <!--end::Card body-->
                <!--begin::Actions-->
                <div class="card-footer d-flex justify-content-end py-6 px-9">
                    <button type="submit" class="btn btn-primary">Submit</button>
                </div>
                <!--end::Actions-->
            </form>
            <!--end::Form-->
            <!--end::Content-->
        </div>
    </div>
@endsection

resources/views/subscription/index.blade.php
@extends('layouts.main')

@section('content')
    <!--begin::Row-->
    <div class="row mb-5 mb-xl-10">
        <div class="card shadow-sm">
            <div class="card-header">
                <h3 class="card-title">Subscription List</h3>
                <div class="card-toolbar">
                    <a href="{{ route('subscription.create') }}" class="btn btn-sm btn-primary">
                        Add
                    </a>
                </div>
            </div>
            <div class="card-body">
                @livewire('subscription-table')
            </div>
        </div>
    </div>
    <!--end::Row-->
@endsection